#include<stdio.h>
#include<process.h>
#include<winsock2.h>

SOCKET	fd;

int
main(void);

//DWORD WINAPI
//waitReceiveThread(LPVOID	pParam);
int
waitReceive(void);

//DWORD WINAPI
//waitReceiveThread(LPVOID	pParam)
int
waitReceive(void)
{
	char	buf[1024];
	int	recvSize;
	int	nRet;
	HANDLE	hEvent = WSACreateEvent();
	WSANETWORKEVENTS	events;

	WSAEventSelect(fd,hEvent,FD_READ|FD_CLOSE);

	while(1)
	{
											/*	Cxg҂				*/
		nRet = WSAWaitForMultipleEvents(1,&hEvent,FALSE,WSA_INFINITE,FALSE);

		if(nRet == WSA_WAIT_FAILED)
		{
			printf("WSAWaitForMultipleEventss\n");
			break;
		}

											/*	Cxg̒				*/
		if(WSAEnumNetworkEvents(fd,hEvent,&events) == SOCKET_ERROR)
		{
			printf("WSAEnumNetworkEventss\n");
		}
		else
		{
											/*	CLOSE						*/
			if(events.lNetworkEvents & FD_CLOSE)
			{
				printf("Close\n");
				closesocket(fd);
				break;
			}
											/*	READ						*/
			if(events.lNetworkEvents & FD_READ)
			{
				recvSize = recv(fd,buf,1024,0);
				printf("Receive %d bytes\n",recvSize);
			}
		}
	}

	WSACloseEvent(hEvent);					/*	CxgN[Y			*/

	return 0;
}

int
main(void)
{
	struct sockaddr_in	addr;
	int	addrlen;
	char	buf[1024];
//	HANDLE	hThread;
//	DWORD	threadId;
	WORD	wVersionRequested = MAKEWORD(2,2);
	WSADATA	wsaData;

	WSAStartup(wVersionRequested,&wsaData);	/*	Winsock				*/

											/*	SOCKET쐬					*/
	if((fd = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) == INVALID_SOCKET)
	{
		perror("socket");
		return -1;
	}

	addr.sin_addr.s_addr = htonl(INADDR_ANY);
	addr.sin_family = AF_INET;
	addr.sin_port = htons(20319);
	
	addrlen = sizeof(addr);
											/*	BIND						*/
	if(bind(fd,(struct sockaddr*)&addr,addrlen) == SOCKET_ERROR)
	{
		perror("bind");
		return -1;
	}

											/*	LISTEN						*/
	if(listen(fd,0) == SOCKET_ERROR)
	{
		perror("listen");
		return -1;
	}

	printf("Listening\n");

											/*	ACCEPT						*/
	if((fd = accept(fd,(struct sockaddr*)&addr,&addrlen)) == INVALID_SOCKET)
	{
		perror("accept");
		return -1;
	}
	
	printf("Accepted\n");

/*	addr.sin_addr.s_addr = inet_addr("127.0.0.1");
	addr.sin_family = AF_INET;
	addr.sin_port = htons(20319);
	
	addrlen = sizeof(addr);*/

											/*	CONNECT						*/
/*	if(connect(fd,(struct sockaddr*)&addr,addrlen) == SOCKET_ERROR)
	{
		perror("connect\n");
		return -1;
	}

	printf("Connected\n");*/

	buf[0] = 91;
	buf[1] = 92;
	buf[2] = 93;
	buf[3] = 94;

	send(fd,buf,4,0);

	waitReceive();
											/*	MXbh			*/
//	hThread = (HANDLE)_beginthreadex(NULL,0,waitReceiveThread,NULL,0,&threadId);

//	WaitForSingleObject(hThread,INFINITE);	/*	MXbhI҂		*/
//	CloseHandle(hThread);					/*	nhN[Y			*/

	WSACleanup();							/*	WinsockI					*/

	return 0;
}
